## endless-sky 0.10.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19...4.0)

include(CMakeDependentOption)
if(UNIX AND NOT APPLE AND NOT ES_STEAM)
	option(ES_USE_VCPKG "Use vcpkg to get dependencies." OFF)
else()
	option(ES_USE_VCPKG "Use vcpkg to get dependencies." ON)
endif()
cmake_dependent_option(ES_GLES "Build the game with OpenGL ES" OFF UNIX OFF)
cmake_dependent_option(ES_STEAM "Build the game for the Steam Linux runtime" OFF UNIX OFF)
cmake_dependent_option(ES_USE_SYSTEM_LIBRARIES "Use system libraries instead of the vcpkg ones." ON "APPLE OR ES_STEAM" OFF)
cmake_dependent_option(ES_CREATE_BUNDLE "Create a Bundle instead of an executable. Not suitable for development purposes." OFF APPLE OFF)

# Support Debug and Release configurations.
set(CMAKE_CONFIGURATION_TYPES "Debug" "Release" CACHE STRING "" FORCE)

# Use C++20 without any compiler specific extensions.
set(CMAKE_CXX_STANDARD 20 CACHE STRING "")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
# We don't use modules, so avoid using unrecognised compiler-specific commands that cmake produces when they are enabled.
set(CMAKE_CXX_SCAN_FOR_MODULES OFF)
# Use LTO for Release builds only.
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG FALSE)
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
# On Linux use relative RPATH.
set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)

# Setup vcpkg.
if(ES_USE_VCPKG)
	set(CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/scripts/buildsystems/vcpkg.cmake"
		CACHE STRING "Vcpkg toolchain file")
	# No need to bootstrap vcpkg if the toolchain file is explicitly provided.
	if(CMAKE_TOOLCHAIN_FILE STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/scripts/buildsystems/vcpkg.cmake")
		include(utils/vcpkg_bootstrap.cmake)
		x_vcpkg_bootstrap()
	endif()

	set(VCPKG_BOOTSTRAP_OPTIONS "-disableMetrics")
	set(VCPKG_INSTALL_OPTIONS "--no-print-usage")
	set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
	set(X_VCPKG_APPLOCAL_DEPS_INSTALL ON)
endif()

if(NOT ES_USE_SYSTEM_LIBRARIES)
	# Tell vcpkg to use the required system libraries.
	list(APPEND VCPKG_MANIFEST_FEATURES "system-libs")
	# Add the testing libraries
	if(NOT APPLE OR CMAKE_OSX_DEPLOYMENT_TARGET VERSION_GREATER_EQUAL 10.12)
		list(APPEND VCPKG_MANIFEST_FEATURES "test-libs")
	endif()
endif()

# Tell vcpkg to use system libraries that are missing in the Steam runtime.
if(ES_STEAM)
	list(APPEND VCPKG_MANIFEST_FEATURES "steam-libs")
endif()

# Various helpful options for IDEs.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT EndlessSky)
set(CMAKE_VS_JUST_MY_CODE_DEBUGGING ON)

project("Endless Sky" VERSION 0.10.14
	DESCRIPTION "Space exploration, trading, and combat game."
	HOMEPAGE_URL https://endless-sky.github.io/
	LANGUAGES CXX)

# Find the needed library dependencies.
find_package(SDL2 CONFIG REQUIRED)
find_package(PNG REQUIRED)
find_package(JPEG REQUIRED)
if(NOT APPLE)
	find_package(GLEW REQUIRED)
endif()

# Only very new versions of OpenAL provide a config package, so try to find it manually.
find_package(OpenAL CONFIG QUIET)
if(NOT OpenAL_FOUND)
	find_library(OPENAL openal REQUIRED)
	add_library(OpenAL UNKNOWN IMPORTED)
	add_library(OpenAL::OpenAL ALIAS OpenAL)
	set_target_properties(OpenAL PROPERTIES IMPORTED_LOCATION "${OPENAL}")
endif()

# libmad doesn't provide native cmake support.
find_path(LIBMAD_INCLUDE_DIR mad.h)
find_library(LIBMAD_LIB_DEBUG NAMES mad libmad NAMES_PER_DIR PATHS "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/debug/lib")
find_library(LIBMAD_LIB_RELEASE NAMES mad libmad NAMES_PER_DIR PATHS "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib")

# Find the zip-reading component of zlib.
find_package(ZLIB REQUIRED)

# Minizip has a different target name in vcpkg.
if(ES_USE_VCPKG)
	find_package(unofficial-minizip CONFIG REQUIRED)
	set(MINIZIP_LIBRARIES "unofficial::minizip::minizip")
else()
	if(CMAKE_VERSION VERSION_LESS 3.31)
		find_package(PkgConfig REQUIRED PkgConfig PkgConf)
		pkg_check_modules(MINIZIP REQUIRED minizip)
	else()
		cmake_pkg_config(EXTRACT minizip REQUIRED)
		set(MINIZIP_LIBRARIES "minizip")
	endif()
endif()

# Find the MinGW runtime DLLs.
if(MINGW AND WIN32)
	# On Windows copy the MinGW runtime DLLs to the output folder as well.
	# This is to avoid the situation where a user has other MinGW runtime DLLs
	# in their PATH that are incompatible with the MinGW used to compile ES.
	get_filename_component(PARENT_DIR "${CMAKE_CXX_COMPILER}" DIRECTORY)
	get_filename_component(MINGW_RUNTIME_DIR "${PARENT_DIR}" DIRECTORY)

	# MinGW doesn't have seh exceptions support for 32-bit Windows unfortunately,
	# and requires libgcc_s_dw2-1.dll instead of libgcc_s_seh-1.dll. There's no
	# perfect way to figure out which one to copy, so we simply copy both.
	# The executable will choose the correct DLL anyways.
	foreach(lib "stdc++-6" "winpthread-1" "gcc_s_seh-1" "gcc_s_dw2-1")
		file(GLOB_RECURSE FILE_PATH "${MINGW_RUNTIME_DIR}/lib${lib}.dll")
		if(FILE_PATH)
			list(APPEND MINGW_RUNTIME "${FILE_PATH}")
		endif()
	endforeach()
endif()

# Add the library target.
add_subdirectory(source)

# Create an interface library that contains common libraries for the game and unit tests.
add_library(ExternalLibraries INTERFACE)
target_link_libraries(EndlessSkyLib PUBLIC ExternalLibraries)

# Enable sanitizers on debug builds, depending on platform support.
if(NOT WIN32)
	set(SANITIZER_OPTS "-g" "-fsanitize=address,undefined,pointer-compare,pointer-subtract,unreachable,builtin,integer-divide-by-zero,vla-bound,null,return,signed-integer-overflow,bounds,alignment,bool,enum,pointer-overflow")
	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		list(APPEND SANITIZER_OPTS "-fno-omit-frame-pointer" "-fsanitize=leak,vptr")
	endif()
endif()
target_compile_options(EndlessSkyLib PUBLIC $<$<CONFIG:Debug>:${SANITIZER_OPTS}>)
target_link_options(EndlessSkyLib PUBLIC $<$<CONFIG:Debug>:${SANITIZER_OPTS}>)

# The 'mingw32' lib needs to be linked first.
if(MINGW)
	target_link_libraries(ExternalLibraries INTERFACE mingw32)
endif()

# Link with the general libraries.
target_link_libraries(ExternalLibraries INTERFACE SDL2::SDL2 PNG::PNG JPEG::JPEG OpenAL::OpenAL ${MINIZIP_LIBRARIES}
	"$<IF:$<CONFIG:Debug>,${LIBMAD_LIB_DEBUG},${LIBMAD_LIB_RELEASE}>")

# Link the needed OS-specific dependencies, if any.
if(WIN32)
	target_link_libraries(ExternalLibraries INTERFACE rpcrt4 Winmm)
elseif(ES_LINK_LIBATOMIC)
	target_link_libraries(ExternalLibraries INTERFACE pthread atomic)
else()
	target_link_libraries(ExternalLibraries INTERFACE pthread)
endif()

# Link with the UUID library, which is different for each OS.
if(UNIX)
	if(APPLE)
		find_library(UUID_LIB NAMES System PATHS /lib /usr/lib /usr/local/lib)
		find_path(UUID_INCLUDE uuid/uuid.h /usr/local/include /usr/include)
		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
		target_include_directories(ExternalLibraries INTERFACE "${UUID_INCLUDE}")
	elseif(NOT ES_USE_VCPKG OR ES_USE_SYSTEM_LIBRARIES)
		find_library(UUID_LIB uuid)
		target_link_libraries(ExternalLibraries INTERFACE "${UUID_LIB}")
	else()
		find_package(unofficial-libuuid CONFIG REQUIRED)
		target_link_libraries(ExternalLibraries INTERFACE unofficial::UUID::uuid)
	endif()
endif()

# Link with OpenGL or OpenGL ES.
if(ES_GLES)
	find_package(OpenGL REQUIRED OpenGL EGL)
	target_link_libraries(ExternalLibraries INTERFACE OpenGL::OpenGL OpenGL::EGL)
	target_compile_definitions(EndlessSkyLib PUBLIC ES_GLES)
else()
	# The Steam runtime can't rely on GLVND being available, so link against the legacy interface.
	if(ES_STEAM)
		set(OpenGL_GL_PREFERENCE "LEGACY")
	endif()

	find_package(OpenGL REQUIRED)
	target_link_libraries(ExternalLibraries INTERFACE OpenGL::GL)

	if(APPLE)
		# Apple deprecated OpenGL in MacOS 10.14, but we don't care.
		target_compile_definitions(EndlessSkyLib PUBLIC GL_SILENCE_DEPRECATION)
	else()
		# GLEW is only needed on Linux and Windows.
		target_link_libraries(ExternalLibraries INTERFACE GLEW::glew)
	endif()
endif()

# Setup for the testing frameworks.
include(CTest)
if(BUILD_TESTING)
	add_subdirectory(tests)
endif()

# Create game target.
if(APPLE AND ES_CREATE_BUNDLE)
	add_executable(EndlessSky MACOSX_BUNDLE source/main.cpp)

	# MacOS bundles are a bit special and need every resource specified when
	# creating the executable.
	# NOTE: This means that a reconfigure is needed if any assets are added/removed!
	foreach(folder "data" "images" "shaders" "sounds")
		file(GLOB_RECURSE RESOURCES "${CMAKE_CURRENT_SOURCE_DIR}/${folder}/*")
		target_sources(EndlessSky PRIVATE "${RESOURCES}")

		foreach(FILE ${RESOURCES})
			# Get the relative path from the root folder to the current file.
			file(RELATIVE_PATH NEW_FILE "${CMAKE_CURRENT_SOURCE_DIR}" "${FILE}")
			# Get the parent directory for the new location.
			get_filename_component(FILE_PATH "${NEW_FILE}" DIRECTORY)

			# Resources belong under Resources/.
			set_source_files_properties("${FILE}" PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/${FILE_PATH}")
		endforeach()
	endforeach()

	# Create the icns file, required for the bundle icon.
	add_custom_command(
		OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/icons/endless-sky.icns"
		COMMAND iconutil -c icns -o icons/endless-sky.icns icons/endless-sky.iconset
		DEPENDS icons/endless-sky.iconset/icon_16x16.png icons/endless-sky.iconset/icon_16x16@2x.png
			icons/endless-sky.iconset/icon_32x32.png icons/endless-sky.iconset/icon_32x32@2x.png
			icons/endless-sky.iconset/icon_128x128.png icons/endless-sky.iconset/icon_128x128@2x.png
			icons/endless-sky.iconset/icon_256x256.png icons/endless-sky.iconset/icon_256x256@2x.png
			icons/endless-sky.iconset/icon_512x512.png icons/endless-sky.iconset/icon_512x512@2x.png
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" VERBATIM)

	# Now do the same to standalone files.
	foreach(file "license.txt" "keys.txt" "credits.txt" "copyright" "changelog" "icons/endless-sky.icns")
		target_sources(EndlessSky PRIVATE ${file})
		set_source_files_properties(${file} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/")
	endforeach()

	# Add plist to bundle.
	set_target_properties(EndlessSky PROPERTIES
		MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_LIST_DIR}/resources/EndlessSky-Info.plist"
		XCODE_ATTRIBUTE_ASSETCATALOG_COMPILER_APPICON_NAME endless-sky)
	set(OUTPUT_NAME "Endless Sky")
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME ${OUTPUT_NAME})
elseif(WIN32)
	add_executable(EndlessSky WIN32 source/main.cpp source/WinApp.rc)
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME "Endless Sky")
else()
	add_executable(EndlessSky source/main.cpp)
	set_target_properties(EndlessSky PROPERTIES OUTPUT_NAME "endless-sky")
endif()

# Link with the library dependencies.
target_link_libraries(EndlessSky PRIVATE ExternalLibraries EndlessSkyLib $<TARGET_NAME_IF_EXISTS:SDL2::SDL2main>)

# Copy the MinGW runtime DLLs if necessary.
if(MINGW AND WIN32)
	foreach(FILE_PATH ${MINGW_RUNTIME})
		add_custom_command(TARGET EndlessSky POST_BUILD
			COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${FILE_PATH}" "$<TARGET_FILE_DIR:EndlessSky>"
			COMMAND_EXPAND_LISTS VERBATIM)

		# Add an install rule for this DLLs, so that it is also included when installing.
		install(FILES ${FILE_PATH} DESTINATION .)
	endforeach()
endif()

# Installation configurations.
if(APPLE)
	install(TARGETS EndlessSky CONFIGURATIONS Release BUNDLE DESTINATION .)
elseif(WIN32)
	# Install the binary.
	install(TARGETS EndlessSky CONFIGURATIONS Release RUNTIME DESTINATION .)

	# The MinGW DLLs needed were already installed above, and vcpkg installs the library DLLs.

	# Install the resource files.
	install(DIRECTORY data DESTINATION .)
	install(DIRECTORY images DESTINATION .)
	install(DIRECTORY shaders DESTINATION .)
	install(DIRECTORY sounds DESTINATION .)
	install(FILES credits.txt DESTINATION .)
	install(FILES keys.txt DESTINATION .)
	install(FILES copyright DESTINATION .)
	install(FILES changelog DESTINATION .)
	install(FILES license.txt DESTINATION .)

	# NSIS installer configuration.

=== source/CMakeLists.txt ===
add_library(EndlessSkyLib OBJECT)

# Set the appropriate compiler flags.
target_include_directories(EndlessSkyLib PUBLIC "${LIBMAD_INCLUDE_DIR}")
if(MSVC)
	target_compile_options(EndlessSkyLib PUBLIC "/W3" "/permissive-" "/sdl" "/GR-" "/analyze-"
		"-Wno-nonportable-include-path" "$<$<CONFIG:Release>:/Gy;/Oi>")
	target_compile_definitions(EndlessSkyLib PUBLIC "_UNICODE" "UNICODE")
else()
	target_compile_options(EndlessSkyLib PUBLIC
		"-Wall" "-pedantic-errors" "-Wold-style-cast" "$<$<CONFIG:Release>:-fno-rtti>")
endif()

# Every source file (and header file) should be listed here, except main.cpp.
# If you add a new file, add it to this list.
target_sources(EndlessSkyLib PRIVATE
	AI.cpp
	AI.h
	Account.cpp
	Account.h
	AlertLabel.cpp
	AlertLabel.h
	AmmoDisplay.cpp
	AmmoDisplay.h
	Angle.cpp
	Angle.h
	Animate.h
	Armament.cpp
	Armament.h
	AsteroidField.cpp
	AsteroidField.h
	BankPanel.cpp
	BankPanel.h
	Bitset.cpp
	Bitset.h
	BoardingPanel.cpp
	BoardingPanel.h
	Body.cpp
	Body.h
	Camera.cpp
	Camera.h
	CaptureOdds.cpp
	CaptureOdds.h
	CargoHold.cpp
	CargoHold.h
	CategoryList.cpp
	CategoryList.h
	CategoryType.h
	ClickZone.h
	Collision.cpp
	Collision.h
	CollisionSet.cpp
	CollisionSet.h
	CollisionType.h
	Color.cpp
	Color.h
	Command.cpp
	Command.h
	ConditionAssignments.cpp
	ConditionAssignments.h
	ConditionEntry.cpp
	ConditionEntry.h
	ConditionSet.cpp
	ConditionSet.h
	ConditionsStore.cpp
	ConditionsStore.h
	Conversation.cpp
	Conversation.h
	ConversationPanel.cpp
	ConversationPanel.h
	CoreStartData.cpp
	CoreStartData.h
	DamageDealt.h
	DamageProfile.cpp
	DamageProfile.h
	DataFile.cpp
	DataFile.h
	DataNode.cpp
	DataNode.h
	DataWriter.cpp
	DataWriter.h
	Date.cpp
	Date.h
	Depreciation.cpp
	Depreciation.h
	Dialog.cpp
	Dialog.h
	Dictionary.cpp
	Dictionary.h
	DistanceCalculationSettings.h
	DistanceCalculationSettings.cpp
	DistanceMap.cpp
	DistanceMap.h
	Distribution.cpp
	Distribution.h
	Effect.cpp
	Effect.h
	Engine.cpp
	Engine.h
	EsUuid.cpp
	EsUuid.h
	EscortDisplay.cpp
	EscortDisplay.h
	ExclusiveItem.h
	FighterHitHelper.h
	Files.cpp
	Files.h
	FireCommand.cpp
	FireCommand.h
	Fleet.cpp
	Fleet.h
	FleetCargo.cpp
	FleetCargo.h
	Flotsam.cpp
	Flotsam.h
	FormationPattern.cpp
	FormationPattern.h
	FormationPositioner.cpp
	FormationPositioner.h
	FrameTimer.cpp
	FrameTimer.h
	Galaxy.cpp
	Galaxy.h
	GameAction.cpp
	GameAction.h
	GameData.cpp
	GameData.h
	GameEvent.cpp
	GameEvent.h
	GameLoadingPanel.cpp
	GameLoadingPanel.h
	Gamerules.cpp
	Gamerules.h
	GameWindow.cpp
	GameWindow.h
	Government.cpp
	Government.h
	HailPanel.cpp
	HailPanel.h
	Hardpoint.cpp
	Hardpoint.h
	Hazard.cpp
	Hazard.h
	HiringPanel.cpp
	HiringPanel.h
	InfoPanelState.cpp
	InfoPanelState.h
	Information.cpp
	Information.h
	Interface.cpp
	Interface.h
	ItemInfoDisplay.cpp
	ItemInfoDisplay.h
	JumpType.h
	Logger.cpp
	Logger.h
	LoadPanel.cpp
	LoadPanel.h
	LocationFilter.cpp
	LocationFilter.h
	LogbookPanel.cpp
	LogbookPanel.h
	MainPanel.cpp
	MainPanel.h
	MapDetailPanel.cpp
	MapDetailPanel.h
	MapOutfitterPanel.cpp
	MapOutfitterPanel.h
	MapPanel.cpp
	MapPanel.h
	MapPlanetCard.cpp
	MapPlanetCard.h
	MapSalesPanel.cpp
	MapSalesPanel.h
	MapShipyardPanel.cpp
	MapShipyardPanel.h
	MenuAnimationPanel.cpp
	MenuAnimationPanel.h
	MenuPanel.cpp
	MenuPanel.h
	MessageLogPanel.cpp
	MessageLogPanel.h
	Messages.cpp
	Messages.h
	Minable.cpp
	Minable.h
	MinableDamageDealt.h
	Mission.cpp
	Mission.h
	MissionAction.cpp
	MissionAction.h
	MissionPanel.cpp
	MissionPanel.h
	Mortgage.cpp
	Mortgage.h
	NPC.cpp
	NPC.h
	NPCAction.cpp
	NPCAction.h
	News.cpp
	News.h
	Outfit.cpp
	Outfit.h
	OutfitInfoDisplay.cpp
	OutfitInfoDisplay.h
	OutfitterPanel.cpp
	OutfitterPanel.h
	Panel.cpp
	Panel.h
	Paragraphs.cpp
	Paragraphs.h
	Person.cpp
	Person.h
	Personality.cpp
	Personality.h
	Phrase.cpp
	Phrase.h
	Planet.cpp
	Planet.h
	PlanetLabel.cpp
	PlanetLabel.h
	PlanetPanel.cpp
	PlanetPanel.h
	PlayerInfo.cpp
	PlayerInfo.h
	PlayerInfoPanel.cpp
	PlayerInfoPanel.h
	Plugins.cpp
	Plugins.h
	Point.cpp
	Point.h
	Politics.cpp
	Politics.h
	Port.cpp
	Port.h
	Preferences.cpp
	Preferences.h
	PreferencesPanel.cpp
	PreferencesPanel.h
	PrintData.cpp
	PrintData.h
	Projectile.cpp
	Projectile.h
	Radar.cpp
	Radar.h
	RaidFleet.cpp
	RaidFleet.h
	Random.cpp
	Random.h
	RandomEvent.h
	Rectangle.cpp
	Rectangle.h
	RenderBuffer.cpp
	RenderBuffer.h
	RouteEdge.cpp
	RouteEdge.h
	RoutePlan.cpp
	RoutePlan.h
	Sale.h
	SavedGame.cpp
	SavedGame.h
	Screen.cpp
	Screen.h
	ScrollBar.cpp
	ScrollBar.h
	ScrollVar.h
	Set.h
	Ship.cpp
	Ship.h
	Shop.h
	ShipEvent.cpp
	ShipEvent.h
	ShipInfoDisplay.cpp
	ShipInfoDisplay.h
	ShipInfoPanel.cpp
	ShipInfoPanel.h
	ShipJumpNavigation.cpp
	ShipJumpNavigation.h
	ShipManager.cpp
	ShipManager.h
	ShipNameDialog.cpp
	ShipNameDialog.h
	ShipyardPanel.cpp
	ShipyardPanel.h
	ShopPanel.cpp
	ShopPanel.h
	SpaceportPanel.cpp
	SpaceportPanel.h
	StartConditions.cpp
	StartConditions.h
	StartConditionsPanel.cpp
	StartConditionsPanel.h
	StellarObject.cpp
	StellarObject.h
	StringInterner.cpp
	StringInterner.h
	Swizzle.cpp
	Swizzle.h
	System.cpp
	System.h
	SystemEntry.h
	TaskQueue.cpp
	TaskQueue.h
	TextArea.cpp
	TextArea.h
	TextReplacements.cpp
	TextReplacements.h
	Trade.cpp
	Trade.h
	TradingPanel.cpp
	TradingPanel.h
	UI.cpp
	UI.h
	UniverseObjects.cpp
	UniverseObjects.h
	Variant.cpp
	Variant.h
	Visual.cpp
	Visual.h
	Weapon.cpp
	Weapon.h
	Weather.cpp
	Weather.h
	WeightedList.h
	Wormhole.cpp
	Wormhole.h
	WormholeStrategy.h
	ZipFile.cpp
	ZipFile.h
	opengl.cpp
	opengl.h
	pi.h
	shift.h
	audio/Audio.cpp
	audio/Audio.h
	audio/Music.cpp
	audio/Music.h
	audio/Sound.cpp
	audio/Sound.h
	audio/SoundCategory.h
	comparators/ByGivenOrder.h
	comparators/ByName.h
	comparators/BySeriesAndIndex.h
	image/BlendingMode.h
	image/ImageBuffer.cpp
	image/ImageBuffer.h
	image/ImageFileData.cpp
	image/ImageFileData.h
	image/ImageSet.cpp
	image/ImageSet.h
	image/Mask.cpp
	image/Mask.h
	image/MaskManager.cpp
	image/MaskManager.h
	image/Sprite.cpp
	image/Sprite.h
	image/SpriteSet.cpp
	image/SpriteSet.h
	shader/BatchDrawList.cpp
	shader/BatchDrawList.h
	shader/BatchShader.cpp
	shader/BatchShader.h
	shader/DrawList.cpp
	shader/DrawList.h
	shader/FillShader.cpp
	shader/FillShader.h
	shader/FogShader.cpp
	shader/FogShader.h
	shader/LineShader.cpp
	shader/LineShader.h
	shader/OutlineShader.cpp
	shader/OutlineShader.h
	shader/PointerShader.cpp
	shader/PointerShader.h
	shader/RingShader.cpp
	shader/RingShader.h
	shader/Shader.cpp
	shader/Shader.h
	shader/SpriteShader.cpp
	shader/SpriteShader.h
	shader/StarField.cpp
	shader/StarField.h
	ship/ShipAICache.cpp
	ship/ShipAICache.h
	test/Test.cpp
	test/Test.h
	test/TestContext.cpp
	test/TestContext.h
	test/TestData.cpp
	test/TestData.h
	text/Alignment.h
	text/Clipboard.cpp
	text/Clipboard.h
	text/DisplayText.cpp
	text/DisplayText.h
	text/Font.cpp
	text/Font.h
	text/FontSet.cpp
	text/FontSet.h
	text/Format.cpp
	text/Format.h
	text/Layout.h
	text/Table.cpp
	text/Table.h
	text/Truncate.h
	text/Utf8.cpp
	text/Utf8.h
	text/WrappedText.cpp
	text/WrappedText.h
)

=== debian/changelog ===
endless-sky (0.10.14-1) unstable; urgency=medium

  * Team upload.
  * Reformat d/control with debputy
  * New upstream version 0.10.14

  [ Patrice Duroux ]
  * d/patches: cleared.
  * d/copyright: synced with upstream. (Closes: #1061241)
  * d/control: add minizip-dev and remove libgl-dev to BD.

 -- Alexandre Detiste <tchet@debian.org>  Sun, 20 Jul 2025 21:03:51 +0200

=== debian/control ===
Source: endless-sky
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Patrice Duroux <patrice.duroux@gmail.com>,
Section: games
Priority: optional
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/games-team/endless-sky
Vcs-Git: https://salsa.debian.org/games-team/endless-sky.git
Homepage: https://endless-sky.github.io
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.21),
 g++ (>=4.6),
 libcatch2-dev,
 libglew-dev,
 libjpeg-dev,
 libmad0-dev,
 libminizip-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 ninja-build,
 uuid-dev,
 xauth <!nocheck>,
 xvfb <!nocheck>,
Rules-Requires-Root: no
X-Style: black

Package: endless-sky
Architecture: any
Depends:
 endless-sky-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: space exploration, trading and combat game
 Explore other star systems.
 .
 Earn money by trading, carrying passengers, or completing missions.
 Use your earnings to buy a better ship or to upgrade the weapons and engines
 on your current one.
 .
 Blow up pirates.
 Take sides in a civil war.
 Or leave human space behind and hope to find some friendly aliens whose
 culture is more civilized than your own...
 .
 Endless Sky is a sandbox-style space exploration game similar to Elite,
 Escape Velocity, or Star Control.
 You start out as the captain of a tiny spaceship and can choose what to do
 from there.
 The game includes a major plot line and many minor missions, but you can
 choose whether you want to play through the plot or strike out on your own as
 a merchant or bounty hunter or explorer.

Package: endless-sky-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: space exploration, trading and combat game - data files
 This package contains the architecture-independent data files for
 endless-sky.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
      https://github.com/endless-sky/endless-sky/tags \
      (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## endless-sky 0.10.16

=== debian/changelog ===
endless-sky (0.10.16-3) unstable; urgency=medium

  * Team upload
  * d/rules: Make the build-time test suite verbose, as per Policy §4.9
    (Closes: #1123894)
  * d/rules: Explicitly use offscreen video driver to run unit tests,
    fixing FTBFS when sdl2-compat provides libsdl2-dev (Closes: #1123893)

 -- Simon McVittie <smcv@debian.org>  Tue, 23 Dec 2025 19:18:31 +0000

endless-sky (0.10.16-2) unstable; urgency=medium

  * Team Upload
  * Rewrite d/watch in v5 format
  * Drop extraneous dep on old g++
  * Skip tests in riscv64

 -- Alexandre Detiste <tchet@debian.org>  Sun, 23 Nov 2025 11:45:00 +0100

endless-sky (0.10.16-1) unstable; urgency=medium

  * New upstream version 0.10.16 (Close: #1112871)
  * d/control: remove RRR: no (default)
  * d/copyright: synced with upstream.
  * d/control: add some B-Ds

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sat, 22 Nov 2025 15:57:51 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 3.21),
- g++ (>=4.6),
+ libavif-dev,
  libcatch2-dev,
+ libflac-dev,
+ libogg-dev,
  libglew-dev,
  libjpeg-dev,
  libmad0-dev,
@@ -24,7 +26,6 @@
  uuid-dev,
  xauth <!nocheck>,
  xvfb <!nocheck>,
-Rules-Requires-Root: no
 X-Style: black
 
 Package: endless-sky

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ --buildsystem=cmake+ninja

# avoid downloading external libraries with git
O += -D ES_USE_VCPKG=0

# release build includes installation of the endless-sky binary
O += -D CMAKE_BUILD_TYPE=Release

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake+ninja -- $O

execute_after_dh_auto_install:
	rm -f debian/tmp/usr/share/doc/endless-sky/license.txt

ctest_env = \
	CTEST_OUTPUT_ON_FAILURE=1 \
	SDL_VIDEODRIVER=offscreen \
	$(NULL)
ctest_options = \
	--label-exclude "(benchmark|integration-debug)" \
	--timeout 9000 \
	$(NULL)
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
ctest_options += --verbose
endif

override_dh_auto_test:
ifneq ($(shell dpkg-architecture -q DEB_BUILD_ARCH),riscv64)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	env -C obj-$(shell dpkg-architecture -q DEB_BUILD_GNU_TYPE) \
		$(ctest_env) \
		ctest $(ctest_options)
endif
endif
